#ifndef BSD_COMPAT_MD5_H
#define BSD_COMPAT_MD5_H

# ifdef HAVE_MD5_DIGEST
#  ifdef USE_OPENSSL_MD5
#   include <openssl/md5.h>
#   define MD5Init(a)          MD5_Init(a)
#   define MD5Update(a,b,c)    MD5_Update(a,b,c)
#   define MD5Final(a,b)       MD5_Final(a,b)
#  else   /* USE_OPENSSL_MD5 */
#   include <md5.h>
#  endif  /* USE_OPENSSL_MD5 */

# else  /* HAVE_MD5_DIGEST */
#  include <stdint.h>

struct md5_state {
  unsigned char buf[64];
  uint32_t state[4];
  uint64_t length;
};

typedef struct md5_state md5_state;

extern void md5_init(md5_state *md);
extern void md5_update(md5_state *md,const unsigned char *in,size_t inlen);
extern void md5_final(md5_state *md, unsigned char *out);

#  define MD5_CTX             md5_state
#  define MD5Init(a)          md5_init(a)
#  define MD5Update(a,b,c)    md5_update(a,b,c)
#  define MD5Final(buf,hash)  md5_final(hash,buf)

# endif  /* HAVE_MD5_DIGEST */

# ifndef MD5_DIGEST_LENGTH
#  define MD5_DIGEST_LENGTH  16
# endif

#endif  /* BSD_COMPAT_MD5_H */
